package demo.spring;

import org.springframework.beans.factory.FactoryBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.config.JtaTransactionManagerFactoryBean;
import org.springframework.transaction.support.TransactionTemplate;

@Configuration
public class Config {
    @Bean
    public FactoryBean<? extends PlatformTransactionManager> txManager() {
        return new JtaTransactionManagerFactoryBean();
    }

    /* Workaround:
    @Bean
    public PlatformTransactionManager txManager() {
        return new JtaTransactionManagerFactoryBean().getObject();
    }*/

    @Bean
    public TransactionTemplate template() {
        return new Template();
    }
}
