package demo.spring;

import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.transaction.jta.JtaTransactionManager;
import org.springframework.transaction.support.TransactionTemplate;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

@WebListener
public class Listener implements ServletContextListener {
    @Override
    public void contextInitialized(ServletContextEvent servletContextEvent) {
        try (ConfigurableApplicationContext context = new AnnotationConfigApplicationContext(Config.class)) {

            JtaTransactionManager transactionManager = context.getBean(JtaTransactionManager.class);

            System.out.println("\n\nTX-Manager properly initialized: " + (transactionManager.getUserTransaction() != null) + "\n\n");

            context.getBean(TransactionTemplate.class).execute(status -> {
                System.out.println("\n\nA transactional action\n\n");
                return null;
            });
        }
    }

    @Override
    public void contextDestroyed(ServletContextEvent servletContextEvent) {
    }
}
